$regfile = "m8def.dat"
$crystal = 8000000
$eepromsize = 512
'$sim

Config Lcdpin = Pin , Rs = Portb.4 , E = Portb.5 , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3

Config Lcd = 16 * 2

Osvit Alias Portc.0
Tlak Alias Portc.1
Pip Alias Portc.2

Tl1 Alias Pind.5                                            'Left
Tl2 Alias Pind.2                                            'Right
Tl3 Alias Pind.4                                            'Up
Tl4 Alias Pind.3                                            'Down
Tl5 Alias Pind.1                                            'Edit
Tl6 Alias Pind.0                                            'Start

Dim Mem As Byte
Dim Zn As Byte
Dim Exh As Byte
Dim Znak As String * 1
Dim Pos As Byte
Dim Cpos As Byte
Dim Casnum As Word
Dim I As Byte
Dim J As Word
Dim X As Byte
Dim Text As String * 11
Dim Cas As String * 3
Dim Exhcas As String * 2
Dim Memname(8) As Eram String * 11
Dim Memtime(8) As Eram String * 3
'Dim Lastmem As Eram Byte

Declare Sub Pipak()
Declare Sub Epromcheck()
Declare Sub Showmem(mem As Byte)

Mem = 1
Ddrc = 255
Ddrb = 255
Ddrd = 0
Portd = 255


Initlcd
Cls
Cursor Off Noblink
Locate 1 , 1
Lcd "Exposition Timer"
Locate 2 , 6
Lcd "v1.2"
Wait 1

Call Epromcheck()

If Tl5 = 0 And Tl6 = 0 Then Goto Clrepr

Prstart:
Cls
Call Pipak
Call Pipak
Locate 1 , 1
Lcd "Pamet:"
Locate 1 , 15
Zn = Mem + 48
Lcd "M"
Lcd Chr(zn)
Call Showmem(mem)

Cycle:
  If Tl1 = 0 Then
    Mem = Mem - 1
    If Mem < 1 Then Mem = 8
    Call Pipak
    Bitwait Tl1 , Set
    Zn = Mem + 48
    Locate 1 , 16
    Lcd Chr(zn)
    Call Showmem(mem)
  End If
  If Tl2 = 0 Then
    Mem = Mem + 1
    If Mem > 8 Then Mem = 1
    Call Pipak
    Bitwait Tl2 , Set
    Zn = Mem + 48
    Locate 1 , 16
    Lcd Chr(zn)
    Call Showmem(mem)
  End If
  If Tl5 = 0 Then
    Call Pipak
    Bitwait Tl5 , Set
    Locate 2 , 1
    Cursor On Blink
    Pos = 1
    Text = "           "
    Text = Memname(mem)
    Znak = Mid(text , Pos , 1)
    Zn = Asc(znak)
    Goto Editname
  End If
  If Tl6 = 0 Then
    Call Pipak
    Bitwait Tl6 , Set
    Cls
    Locate 1 , 1
    Lcd Text
    Locate 1 , 13
    Lcd Cas
    Lcd "s"
    Goto Cntstart
  End If

Goto Cycle

Editname:
If Tl2 = 0 Then
  Call Pipak
  Bitwait Tl2 , Set
  Pos = Pos + 1
  If Pos = 12 Then Pos = 13
  If Pos > 15 Then Pos = 1
  Locate 2 , Pos
  If Pos < 12 Then
    Znak = Mid(text , Pos , 1)
  Else
    Cpos = Pos - 12
    Znak = Mid(cas , Cpos , 1)
  End If
  Zn = Asc(znak)
End If
If Tl1 = 0 Then
  Call Pipak
  Bitwait Tl1 , Set
  Pos = Pos - 1
  If Pos < 1 Then Pos = 15
  If Pos = 12 Then Pos = 11
  Locate 2 , Pos
    If Pos < 12 Then
    Znak = Mid(text , Pos , 1)
  Else
    Cpos = Pos - 12
    Znak = Mid(cas , Cpos , 1)
  End If
  Zn = Asc(znak)
End If
If Tl3 = 0 Then
  Call Pipak
  Bitwait Tl3 , Set
  Zn = Zn + 1
  If Zn > 128 Then Zn = 32
  If Zn < 32 Then Zn = 128
  If Pos > 12 Then
    If Zn > 57 Then Zn = 48
    If Zn < 48 Then Zn = 57
  End If
  Locate 2 , Pos
  Lcd Chr(zn)
  Locate 2 , Pos
  If Pos < 12 Then
    Mid(text , Pos , 1) = Chr(zn)
  Else
    Cpos = Pos - 12
    Mid(cas , Cpos , 1) = Chr(zn)
  End If
End If
If Tl4 = 0 Then
  Call Pipak
  Bitwait Tl4 , Set
  Zn = Zn - 1
  If Zn > 128 Then Zn = 32
  If Zn < 32 Then Zn = 128
  If Pos > 12 Then
    If Zn > 57 Then Zn = 48
    If Zn < 48 Then Zn = 57
  End If
  Locate 2 , Pos
  Lcd Chr(zn)
  Locate 2 , Pos
  If Pos < 12 Then
    Mid(text , Pos , 1) = Chr(zn)
  Else
    Cpos = Pos - 12
    Mid(cas , Cpos , 1) = Chr(zn)
  End If
End If
If Tl5 = 0 Then
  Call Pipak
  Bitwait Tl5 , Set
  Cursor Off Noblink
  Call Showmem(mem)
  Goto Cycle
End If
If Tl6 = 0 Then
  Call Pipak
  Bitwait Tl6 , Set
  Memname(mem) = Text
  Memtime(mem) = Cas
  Cursor Off Noblink
  Goto Cycle
End If
Goto Editname

Cntstart:
If Tl5 = 0 Then
  Call Pipak
  Bitwait Tl5 , Set
  Goto Prstart
End If
If Tl6 = 0 Then
  Call Pipak
  Call Pipak
  Bitwait Tl6 , Set
  Goto Cntexec
End If
Goto Cntstart

Cntexec:
Locate 2 , 1
Lcd "Odsavanie: "
Exh = 15
Tlak = 1
For I = Exh To 0 Step -1
  Locate 2 , 12
  Exhcas = Str(i)
  If I < 10 Then Lcd " "
  Lcd Exhcas
  Lcd "s"
  Wait 1
  If Tl5 = 0 Then
    Call Pipak
    Bitwait Tl5 , Set
    Tlak = 0
    Osvit = 0
    Goto Prstart
  End If
Next I
Wait 1
Locate 2 , 1
Lcd String(16 , 32)
Cas = "000"
Cas = Memtime(mem)
Casnum = Val(cas)
Osvit = 1
Locate 1 , 1
Lcd "Osvit:          "
For J = Casnum To 0 Step -1
  Locate 1 , 13
  Cas = Str(j)
  If J < 100 Then Lcd " "
  If J < 10 Then Lcd " "
  Lcd Cas
  Lcd "s"
  Wait 1
  If Tl5 = 0 Then
    Call Pipak
    Bitwait Tl5 , Set
    Tlak = 0
    Osvit = 0
    Goto Prstart
  End If
Next J
Tlak = 0
Osvit = 0
Call Pipak
Call Pipak
Call Pipak
Locate 2 , 1
Lcd "     HOTOVO!"
Bitwait Tl6 , Reset
Goto Prstart

Clrepr:
Call Pipak
Call Pipak
Cls
Locate 1 , 1
Lcd "Vymazat pamete?"
Locate 2 , 1
Lcd "A=Start, N=Stop"
Bitwait Tl5 , Set
Bitwait Tl6 , Set
Btnepr:
If Tl5 = 0 Then
  Call Pipak
  Bitwait Tl5 , Set
  Goto Prstart
End If
If Tl6 = 0 Then
  Call Pipak
  Bitwait Tl6 , Set
  Goto Clrall
End If
Goto Btnepr

Clrall:
For I = 1 To 8
Memname(i) = "           "
Memtime(i) = "000"
Next I
Goto Prstart

Sub Pipak()
  Pip = 1
  Waitms 50
  Pip = 0
  Waitms 50
End Sub

Sub Showmem(byval Mem As Byte)
  Locate 2 , 1
  Text = "           "
  Lcd Text
  Locate 2 , 1
  Text = Memname(mem)
  Lcd Text
  Cas = "000"
  Locate 2 , 13
  Lcd Cas
  Cas = Memtime(mem)
  Locate 2 , 13
  Lcd Cas
  Lcd "s"
End Sub

Sub Epromcheck()
For I = 1 To 8
  X = 0
  Text = "           "
  Text = Memname(i)
  For J = 1 To 11
    Znak = Mid(text , J , 1)
    Zn = Asc(znak)
    If Zn < 32 Or Zn > 128 Then
      Mid(text , J , 1) = " "
      X = 1
    End If
  Next J
  If X <> 0 Then
    Memname(i) = Text
  End If
Next I
For I = 1 To 8
  X = 0
  Cas = Memtime(i)
  For J = 1 To 3
    Znak = Mid(cas , J , 1)
    Zn = Asc(znak)
    If Zn < "0" Or Zn > "9" Then
      Mid(cas , J , 1) = "0"
      X = 1
    End If
  Next J
  If X <> 0 Then
    Memtime(i) = Cas
  End If
Next I
End Sub


End                                                         'end program